<?php
/* ReplayCharge v1.0
 *
 * Plugin by Leigham. With thanks to Xymph, from whom I stole some code :)
 *
 * Important: This plugin will only work on a TM2 server. 
 * The server must have at least a small amount of planets for
 * the plugin to work.
 *
 * Scroll down to configure plugin settings.
 */

Aseco::registerEvent('onPlayerConnect', 'replaychargeOn');
Aseco::registerEvent('onBeginMap', 'replaychargeOn');
Aseco::registerEvent('onEndMap', 'replaychargeOff');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'replaychargeClick');
Aseco::registerEvent('onBillUpdated', 'replaychargeBill');

global $position, $planets, $replaybills;

// Configuration settings below

$position = '-63.8 -17.5 1';    // Position of the manialink. 'X Y Z'
$planets = 85;   // Copper cost to replay the track
// End of config

$replaybills = array();

function replaychargeOn($aseco) {
	global $position, $planets;
	
	$xml = '<manialink id="1234512301">
    <frame posn="'.$position.'">
        <quad posn="0 0 0" sizen="23 5" style="BgsPlayerCard" substyle="BgCardSystem" action="234561"></quad>
        <label posn="11.3 -2.4 1" sizen="23 5" halign="center" valign="center" textsize="2.5" textcolor="FFFF" text="Replay track for '.$planets.' planets!"></label>
    </frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeSuccess($aseco) {
	global $position;
	
	$xml = '<manialink id="1234512301">
    <frame posn="'.$position.'">
        <quad posn="0 0 0" sizen="23 5" style="BgsPlayerCard" substyle="BgCardSystem"></quad>
        <label posn="11.3 -2.4 1" sizen="23 5" halign="center" valign="center" textsize="2.5" textcolor="FFFF" text="Track is being replayed!"></label>
    </frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeOff($aseco) {
	
	$xml = '<manialink id="1234512301">
		<frame posn="0 0 0">
			<quad posn="0 0 0" sizen="0 0" halign="center" valign="center" action="234561"></quad>
		</frame>
	</manialink>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function replaychargeClick($aseco, $command) {
	global $planets, $replaybills;
	
	$playerid = $command[0];
	$login = $command[1];
	$answer = $command[2].'';
	$aseco->client->query('GetDetailedPlayerInfo', $login);
	$player = $aseco->client->getResponse();
	$nickname = $player['NickName'];
		if ($answer == '234561') {
		$aseco->client->query('GetCurrentMapInfo');
		$thistrack = $aseco->client->getResponse();
		$aseco->client->query('GetNextMapInfo');
		$nexttrack = $aseco->client->getResponse();
		// Check if already being replayed
		if ($thistrack['FileName'] != $nexttrack['FileName']) {	
						// start the transaction
						$message = 'You need to pay '.$planets.' planets to replay the track';
						$aseco->client->query('SendBill', $login, $planets, $message, '');
						$replaybillid = $aseco->client->getResponse();
						$replaybills[$replaybillid] = array($login, $nickname, $planets, $thistrack);
		} else {
		$message = '>$f00 This track is already being replayed';
		$aseco->client->query('ChatSendServerMessageToLogin', $message, $login);
		}
	}
}
		// [0]=BillId, [1]=State, [2]=StateName, [3]=TransactionId
function replaychargeBill($aseco, $replaybill) {
	global $replaybills;
	$replaybillid = $replaybill[0];
	// check for known bill ID
	if (array_key_exists($replaybillid, $replaybills)) {
		// get bill info
		$login = $replaybills[$replaybillid][0];
		$nickname = $replaybills[$replaybillid][1];
		$planets = $replaybills[$replaybillid][2];
		$thistrack = $replaybills[$replaybillid][3];
				// check bill state
		switch($replaybill[1]) {
		case 4:  // Payed (Paid)
				$track = $thistrack['FileName'];
				$message = '$f90Player $z'.$nickname.'$z$f90  pays '.$planets.' planets and queues map for replay!';
				$aseco->client->query('ChooseNextMap', $track);
				$aseco->client->query('ChatSendServerMessage', $message);
				$aseco->console('Player {1} paid {2} planets to replay the current track', $login, $planets);
			unset($replaybills[$replaybillid]);
			replaychargeSuccess($aseco);
			break;
		case 5:  // Refused
			$message = '{#server}> {#error}Transaction refused!';
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			unset($replaybills[$replaybillid]);
			break;
		case 6:  // Error
			$message = '{#server}> {#error}Transaction failed: {#highlite}$i ' . $replaybill[2];
			if ($login != '')
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			else
				$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			unset($replaybills[$replaybillid]);
			break;
		default:  // CreatingTransaction/Issued/ValidatingPay(e)ment
			break;
		}
	}
}
?>